import java.lang.reflect.Array;
import java.util.Arrays;

public class MyArrayList<T extends Object> implements MyCollections {

    private T[] store;
    private int index = 0;
    private int size = 0;

    public MyArrayList(){
        this.store = (T[])new Object[1];
    }

    public MyArrayList(int size){
        this.store = (T[])new Object[size + 1];
        this.index = 10;
    }

    public void add(T object){
        if(index < this.store.length) {
            this.store[index] = object;
            this.size++;
            this.index++;
        } else {
            this.store = increase(this.store);
            this.store[index] = object;
            this.index ++;

        }
    }

    public void add(T object, int index){
        while (index >= this.store.length){
            this.store = increase(this.store);
        }
        this.store[index] = object;

    }

    public T[] increase(T[] arr){
        int len = arr.length;
        size ++;
        T[] newArr = (T[])new Object[len + 1];
        for(int i = 0; i < arr.length; i ++){
            newArr[i] = arr[i];
        }
        return newArr;
    }

    public int size(){
        return this.size;
    }

    public T get(int get){
        return store[get];
    }

    public void remove(int index) {
        int len = this.store.length;
        size --;
        T[] newArr = (T[])new Object[len - 1];

        for(int i = 0; i < this.store.length; i ++){
            if(i < index){
                newArr[i] = this.store[i];
            } else if(i > index) {
                newArr[i - 1] = this.store[i];
            }
        }
        this.store = newArr;
    }

    public void remove(T object){
        for(int i = 0; i < this.store.length; i ++){
            if(this.store[i].equals(object)){
                this.remove(i);
                this.index --;
                break;
            }
        }
    }

    public void set(T elm, int index){
        this.store[index] = elm;
    }

    public void clear(){
        this.store = (T[])new Object[1];
        this.size = 0;
    }

    public boolean isEmpty() {
        return this.size == 0;
    }

    public boolean contains(T object) {
        if(this.size > 0) {
            for (int i = 0; i < this.store.length; i++) {
                if (this.store[i].equals(object)) {
                    return true;
                }
            }
        }
        return false;
    }

    public void removeRange(int start, int end) {
        if(end > start) {
            for(int i = start; i <= end; i ++){
                this.remove(i);
            }
        }
    }

    public T[] toArray(T[] arr){
        for(int i = 0; i < arr.length; i ++){
            arr[i] = this.store[i];
        }
        return arr;
    }
}
