public class MyMap <T extends Object, E extends Object> {

    private MyArrayList<Entry> entries = new MyArrayList<>();

    public class Entry{
        T key = null;
        E val = null;

        public Entry(){}

        public Entry(T key, E value){
            this.key = key;
            this.val = value;
        }

        public void setKey(T object){
            this.key = (object);
        }

        public T getKeys(){
            return this.key;
        }

        public void setVal(E object){
            this.val = (object);
        }

        public E getVals(){
            return this.val;
        }

    }


    public MyMap(){

    }

    public void put(T key, E val) {
        if(!containsKey(key)){
            entries.add(new Entry(key, val));
        } else {
            for(int i = 0; i < entries.size(); i ++){
                if(entries.get(i).getKeys().equals(key)){
                    entries.remove(entries.get(i));
                }
            }
            entries.add(new Entry(key, val));
        }
    }

    public int size() {
        return entries.size();
    }

    public E get(T key) {
        for(int i = 0; i < keySet().length; i ++){
            if(keySet()[i].equals(key)){
                return entries.get(i).getVals();
            }
        }
        return null;
    }

    public void remove(T key) {
        System.out.println(entries.size());
        for(int i = 0; i < entries.size(); i ++){
            if(entries.get(i).getKeys().equals(key)){
                entries.remove(entries.get(i));
            }
        }
    }

    public boolean containsKey(T key) {
        for(int i = 0; i < entries.size(); i ++){
            System.out.println(entries.get(i).getKeys());
            if(entries.get(i).getKeys().equals(key)){
                return true;
            }
        }
        return false;
    }

    public T[] keySet() {
        T[] arr = (T[])new Object[getKeyCount()];

        for(int i = 0; i < entries.size(); i ++){
            arr[i] = entries.get(i).getKeys();
        }
        return arr;
    }

    private int getKeyCount(){
        return entries.size();
    }
}
