public class MySet<T extends Object> implements MyCollections{

    //private T[] store = (T[])new Object[1];
    private MyArrayList<T> store;
    private int index = 0;
    private int size = 0;

    public MySet(MyArrayList<T> store2) {
        this.store = store2;
    }

    public MySet() {
        this.store = new MyArrayList<T>();
    }

    public boolean add(T item) {
        if(!store.contains(item)) {
            store.add(item);
            return true;
        } else {
            return false;
        }

    }

    public boolean contains(T item) {
        if (store.size() > 0) {
            for (int i = 0; i < store.size(); i++) {
                if (store.get(i).equals(item)) {
                    return true;
                }
            }
        }
        return false;
    }

    public int size(){
        return this.store.size();
    }

    public void addAll(MyCollections<T> list) {
        for(int i = 0; i < list.size(); i ++){
            this.add(list.get(i));
        }
    }

    public boolean isEmpty() {
        return this.store.size() == 0;
    }

    public T[] toArray(T[] arr) {
        for(int i = 0; i < arr.length; i ++){
            arr[i] = this.store.get(i);
        }
        return arr;
    }

    public T get(int index){
        return this.store.get(index);
    }
}
